# Comparison between Controlify 1.1.0 and Midnight Controls 1.8.0

|                                          | Controlify (1.3.0)                                                                                                                             | [Midnight Controls](https://github.com/TeamMidnightDust/MidnightControls)                |     | [Controller Support Mod](https://github.com/Stereowalker/Controller-Support-Mod) |
|------------------------------------------|------------------------------------------------------------------------------------------------------------------------------------------------|------------------------------------------------------------------------------------------|-----|----------------------------------------------------------------------------------|
| **Mod Updates**                          | Frequent mod updates with new features                                                                                                         | Generally inactive. Updates to new versions quickly.                                     |     | Inactive, stuck on 1.19.3                                                        |
| **Custom Screen Compatibility**          | Convenient APIs to hook into controller support directly from `Screen` implementation.                                                         | No API. Sometimes necessary to mixin into Midnight Controls and edge-case code required. |     | ⛔                                                                                |
| **Screen Navigation**                    | 4-axis navigation, emulating arrow key navigation                                                                                              | 4-axis navigation, emulating arrow key navigation                                        |     | 2-axis tab-key emulation                                                         |
| **Controller rumble**                    | ✅ Individual rumble effect intensity configuration                                                                                             | ⛔                                                                                        |     | ⛔                                                                                |
| **In-game button guide**                 | Extensible by 3rd party mods                                                                                                                   | Harcoded buttons and positions                                                           |     | ⛔                                                                                |
| **Reach-around block placement**         | ✅ Emulates Bedrock Edition reach-around                                                                                                        | ✅                                                                                        |     | ⛔                                                                                |
| **Gyro support**                         | ✅                                                                                                                                              | ⛔                                                                                        |     | ⛔                                                                                |
| **Controller detection**                 | Powered by resource packs for unlimited data-driven detection                                                                                  | Hardcoded identifiers in code                                                            |     | Data-driven detection but seems hardcoded                                        |
| **Controller button rendering**          | Powered by resource pack controller detection                                                                                                  | Texture atlas for hardcoded identifiers                                                  |     | Data-driven resource packs                                                       |
| **In-game look sensitivity & behaviour** | Emulated Bedrock Edition with good defaults and snappy behaviour                                                                               | Default sensitivity is insane - more testing required                                    |     | needs testing                                                                    |
| **Container interaction**                | Controlled cursor snaps to container slots (with API) with power of left click, right click and shift click. Button guide available at bottom. | Basic mouse & keyboard emulation                                                         |     | Basic mouse & keyboard emulation                                                 |
| **Touchscreen support**                  | ⛔                                                                                                                                              | ⛔ Reported broken by author                                                              |     | ⛔                                                                                |
| **Joystick support**                     | ✅ Multiple joysticks can be combined together (no UI yet)                                                                                      | ✅ Multiple joysticks can be combined together                                            |     | Single joysticks data-driven                                                     |
| **Joystick mapping**                     | Powered by resource packs, unlimited amount of buttons available                                                                               | All combined joysticks limited to gamepad input. Powered by SDL mappings                 |     | Powered by resource packs                                                        |
| **Configurability**                      | Each controller has individual settings with the ability to map every single controller action. No hardcoding!                                 | needs testing                                                                            |     | None                                                                             |
| **Mod keybindings**                      | ✅                                                                                                                                              | ✅                                                                                        |     | ✅                                                                                |
| **On-screen keyboard**                   | ⛔ Allows chat window to be shifted up for system on-screen keyboards                                                                           | ⛔                                                                                        |     | ✅                                                                                |
